Skip to main content
`Ctrl`+`K`

# skbio.util.classproperty

class skbio.util.classproperty(func)

  Decorator for class-level properties.

  Supports read access only. The property will be read-only within an instance. However, the property can always be redefined on the class, since Python classes are mutable.

  Parameters:
    func function

      Method to make a class property.

  Returns:
    property

      Decorated method.

  Raises:
    AttributeError

      If the property is set on an instance.

  Attributes (inherited)

  `fdel` |
  `fget` |
  `fset` |

  Methods (inherited)

  `deleter`(object, /) | Descriptor to obtain a copy of the property with a different deleter.
  `getter`(object, /) | Descriptor to obtain a copy of the property with a different getter.
  `setter`(object, /) | Descriptor to obtain a copy of the property with a different setter.

  Special methods

  `__get__`(cls, owner) | Return an attribute of instance, which is of type owner.
  `__set__`(obj, value) | Set an attribute of instance to value.

  Special methods (inherited)

  `__delete__`(instance, /) | Delete an attribute of instance.
  `__eq__`(value, /) | Return self==value.
  `__ge__`(value, /) | Return self>=value.
  `__getstate__`(/) | Helper for pickle.
  `__gt__`(value, /) | Return self>value.
  `__hash__`(/) | Return hash(self).
  `__le__`(value, /) | Return self<=value.
  `__lt__`(value, /) | Return self<value.
  `__ne__`(value, /) | Return self!=value.
  `__set_name__`(owner, name, /) | Method to set name of a property.
  `__str__`(/) | Return str(self).

  Details

  __get__(cls, owner)

    Return an attribute of instance, which is of type owner.

  __set__(obj, value)

    Set an attribute of instance to value.